package br.jus.cnj.selointegracaoclient;

import java.io.File;
import java.net.URL;
import java.util.Random;

import javax.ws.rs.core.MediaType;

import com.sun.jersey.api.client.Client;
import com.sun.jersey.api.client.ClientResponse;
import com.sun.jersey.api.client.WebResource;
import com.sun.jersey.api.client.config.ClientConfig;
import com.sun.jersey.api.client.config.DefaultClientConfig;
import com.sun.jersey.api.client.filter.HTTPBasicAuthFilter;
import com.sun.jersey.multipart.FormDataMultiPart;
import com.sun.jersey.multipart.MultiPart;
import com.sun.jersey.multipart.file.FileDataBodyPart;
import com.sun.jersey.multipart.impl.MultiPartWriter;

public class ClientXML {

	public static void main(String[] args) throws Exception {
		testarConexao();
		enviarProcessos();
		totalProcessos();
	}

	public static void testarConexao() {
		try {
			final Client client = Client.create();
			client.addFilter(new HTTPBasicAuthFilter("TRIBUNAL", "SENHA"));

			final WebResource resource = client.resource("https://wwwh.cnj.jus.br/selo-integracao-web/v1/processos");
			ClientResponse response = resource.get(ClientResponse.class);
			System.out.println(response.getEntity(String.class));
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	public static void enviarProcessos() {
		final ClientConfig config = new DefaultClientConfig();
		config.getClasses().add(MultiPartWriter.class);

		final Client client = Client.create(config);
		client.addFilter(new HTTPBasicAuthFilter("TRIBUNAL", "SENHA"));
		final WebResource resource = client.resource("https://wwwh.cnj.jus.br/selo-integracao-web/v1/processos/G2");

		URL openStream = ClientXML.class.getClassLoader().getResource("processo.xml");
		FileDataBodyPart filePart = new FileDataBodyPart("file", new File(openStream.getFile()),
				MediaType.APPLICATION_OCTET_STREAM_TYPE);

		MultiPart multiPart = new FormDataMultiPart().bodyPart(filePart);
		multiPart.setMediaType(MediaType.MULTIPART_FORM_DATA_TYPE);

		ClientResponse response = resource.type("multipart/form-data").post(ClientResponse.class, multiPart);
		System.out.println(response.getEntity(String.class));

		client.destroy();
	}

	public static void totalProcessos() {
		try {
			final Client client = Client.create();
			client.addFilter(new HTTPBasicAuthFilter("TRIBUNAL", "SENHA"));

			final WebResource resource = client
					.resource("https://wwwh.cnj.jus.br/selo-integracao-web/v1/processos/total");
			ClientResponse response = resource.get(ClientResponse.class);
			System.out.println(response.getEntity(String.class));
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

}
